// tcpipDlg.cpp : implementation file
//

#include "stdafx.h"
#include "tcpip.h"
#include "tcpipDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTcpipDlg dialog

CTcpipDlg::CTcpipDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTcpipDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTcpipDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTcpipDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTcpipDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTcpipDlg, CDialog)
	//{{AFX_MSG_MAP(CTcpipDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_PREV, OnButtonPrev)
	ON_BN_CLICKED(IDC_BUTTON_NEXT, OnButtonNext)
	ON_BN_CLICKED(IDC_BUTTON_FINISH, OnButtonFinish)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTcpipDlg message handlers

BOOL CTcpipDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
//	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	static_cast<CStatic*>(GetDlgItem(IDC_STATIC_FRAME))->GetWindowRect(m_rFrame);
	ScreenToClient(m_rFrame);
	m_rFrame.DeflateRect(2,2,2,2);

	m_dPage1.Create(IDD_PAGE1, this);
	m_dPage1.SetWindowPos(NULL,
		m_rFrame.top, m_rFrame.left,
		m_rFrame.right - m_rFrame.left,
		m_rFrame.bottom - m_rFrame.top,
		SWP_NOZORDER | SWP_SHOWWINDOW );

	m_dPage2.Create(IDD_PAGE2, this);
	m_dPage2.SetWindowPos(NULL,
		m_rFrame.top, m_rFrame.left,
		m_rFrame.right - m_rFrame.left,
		m_rFrame.bottom - m_rFrame.top,
		SWP_NOZORDER | SWP_HIDEWINDOW );

	m_dPage3.Create(IDD_PAGE3, this);
	m_dPage3.SetWindowPos(NULL,
		m_rFrame.top, m_rFrame.left,
		m_rFrame.right - m_rFrame.left,
		m_rFrame.bottom - m_rFrame.top,
		SWP_NOZORDER | SWP_HIDEWINDOW );

	m_dPage4.Create(IDD_PAGE4, this);
	m_dPage4.SetWindowPos(NULL,
		m_rFrame.top, m_rFrame.left,
		m_rFrame.right - m_rFrame.left,
		m_rFrame.bottom - m_rFrame.top,
		SWP_NOZORDER | SWP_HIDEWINDOW );

	m_dPage5.Create(IDD_PAGE5, this);
	m_dPage5.SetWindowPos(NULL,
		m_rFrame.top, m_rFrame.left,
		m_rFrame.right - m_rFrame.left,
		m_rFrame.bottom - m_rFrame.top,
		SWP_NOZORDER | SWP_HIDEWINDOW );

	m_dPage6.Create(IDD_PAGE6, this);
	m_dPage6.SetWindowPos(NULL,
		m_rFrame.top, m_rFrame.left,
		m_rFrame.right - m_rFrame.left,
		m_rFrame.bottom - m_rFrame.top,
		SWP_NOZORDER | SWP_HIDEWINDOW );

	m_nCurPage = 0;

	GetDlgItem(IDC_BUTTON_FINISH)->EnableWindow(false);
	GetDlgItem(IDC_BUTTON_PREV)->EnableWindow(false);

	m_dCurPage = static_cast<CWnd*>(&m_dPage1);
	m_dCurPage->SetFocus();

	return FALSE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTcpipDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTcpipDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTcpipDlg::OnOK() 
{
	if ( GetKeyState(VK_RETURN) >= 0 )
		CDialog::OnOK();
}

void CTcpipDlg::OnCancel() 
{
	if ( GetKeyState(VK_ESCAPE) >= 0 )
		CDialog::OnCancel();
}

void CTcpipDlg::OnButtonPrev() 
{
	ProcPage(false);
}

void CTcpipDlg::OnButtonNext() 
{
	ProcPage(true);
}

void CTcpipDlg::OnButtonFinish() 
{
	CDialog::OnOK();
}

void CTcpipDlg::ProcPage( bool next )
{
	m_dCurPage->ShowWindow(SW_HIDE);

	if (next)
		m_nCurPage++;
	else
		m_nCurPage--;
	
	switch ( m_nCurPage )
	{
	case 1:
		GetDlgItem(IDC_BUTTON_PREV)->EnableWindow(true);
		GetDlgItem(IDC_BUTTON_FINISH)->EnableWindow(false);
		GetDlgItem(IDC_BUTTON_NEXT)->EnableWindow(true);
		m_dCurPage = static_cast<CWnd*>(&m_dPage2);
		break;
	case 2:
		GetDlgItem(IDC_BUTTON_PREV)->EnableWindow(true);
		GetDlgItem(IDC_BUTTON_FINISH)->EnableWindow(false);
		GetDlgItem(IDC_BUTTON_NEXT)->EnableWindow(true);
		m_dCurPage = static_cast<CWnd*>(&m_dPage3);
		break;
	case 3:
		GetDlgItem(IDC_BUTTON_PREV)->EnableWindow(true);
		GetDlgItem(IDC_BUTTON_FINISH)->EnableWindow(false);
		GetDlgItem(IDC_BUTTON_NEXT)->EnableWindow(true);
		m_dCurPage = static_cast<CWnd*>(&m_dPage4);
		break;
	case 4:
		GetDlgItem(IDC_BUTTON_FINISH)->EnableWindow(false);
		GetDlgItem(IDC_BUTTON_FINISH)->EnableWindow(false);
		GetDlgItem(IDC_BUTTON_NEXT)->EnableWindow(true);
		m_dCurPage = static_cast<CWnd*>(&m_dPage5);
		break;
	case 5:
		GetDlgItem(IDC_BUTTON_FINISH)->EnableWindow(true);
		GetDlgItem(IDC_BUTTON_NEXT)->EnableWindow(false);
		m_dCurPage = static_cast<CWnd*>(&m_dPage6);
		break;
	default:
		GetDlgItem(IDC_BUTTON_FINISH)->EnableWindow(false);
		GetDlgItem(IDC_BUTTON_PREV)->EnableWindow(false);
		GetDlgItem(IDC_BUTTON_NEXT)->EnableWindow(true);
		m_dCurPage = static_cast<CWnd*>(&m_dPage1);
		m_nCurPage = 0;
		break;
	}

	m_dCurPage->ShowWindow(SW_SHOW);
	m_dCurPage->SetFocus();
}
